
#include <iostream.h>
#include <stdlib.h>
#include "flilib.h"
#include "gfx.h"

void main(int argc, char *argv[])
{
	_settextcolor (10);
	_outtext("\n  Fliccisoitin v2.0");
	_settextcolor (15);
	_outtext(" - (C) 1998 Sami Kystil\n");
	fli *ani;
	short argnum=4;

	if (argc>1) 
	{
		if (argc>2)
		{
			if ((argv[2][0]=='m') || (argv[2][0]=='M') || (argv[2][0]=='d') || (argv[2][0]=='D'))
				argnum = 2;
	    switch (argv[argnum][0]) {
	        case 'd':
	        		cout << "\nLadataan tiedostoa " << argv[1] << "..." << endl;
	            ani = fli_load(argv[1], FLI_DISK);
	            break;
	        case 'D':
	        		cout << "\nLadataan tiedostoa " << argv[1] << "..." << endl;
	            ani = fli_load(argv[1], FLI_DISK);
	            break;
	        case 'm':
	        		cout << "\nLadataan tiedostoa " << argv[1] << " kokonaan muistiin..." << endl;
	            ani = fli_load(argv[1], FLI_RAM);
	            break;
	        case 'M':
	        		cout << "\nLadataan tiedostoa " << argv[1] << " kokonaan muistiin..." << endl;
	            ani = fli_load(argv[1], FLI_RAM);
	            break;
	        default:
	        		cout << "\nLadataan tiedostoa " << argv[1] << "..." << endl;
	            ani = fli_load(argv[1], FLI_AUTO);
	            break;
	   	}
	   } else 
	   {
   		cout << "\nLadataan tiedostoa " << argv[1] << "..." << endl;
       ani = fli_load(argv[1], FLI_AUTO);
     }
	}
	else 
	{
		cout << endl;
		cout << " Soittaa komentorivill annetun fli/flc tiedoston miss tahansa\n";
		cout << " tuetussa Vesa VBE 2.0 videoresoluutiossa (LFB tai ilman)\n";
		cout << " joko suoraan levylt tai kokonaan muistista.\n\n";
		
		cout << " Kytt:" << endl;
		cout << endl;
		cout << argv[0] << " [tiedosto.fli/flc] [VideoXres VideoYres] [M/D]" << endl;
		cout << endl;
		cout << "VideoXres VideoYres - Videoresoluutio jossa flicci pyritetn\n";
		cout << "                      esim: 640 480. Defaulttina resoluutio\n";
		cout << "                      valitaan automaattisesti 320x200:sta ylspin.\n\n";
		
		cout << "                M/D - Ladataanko animaatio kokonaan muistiin (M)\n";
		cout << "                      vai soitetaanko se levylt (D)\n";
		cout << "                      Defaultti on M jos muisti riitt,\n";
		cout << "                      muutoin D.\n";
		cout << endl;
		cout << " Napit:     [Space] : Seek mode ([/] : eteen/taakse)\n"; 
		cout << "              [+/-] : Nopeus\n";
		cout << "              [Esc] : Lopetus\n";
		return;
	}


  if (ani == NULL) 
  {
		cout << " * Virhe ladattaessa tiedostoa!\n";
		close_fli(ani);
		return;
	}
	
	cout << "Luetaan frametiedot...\n" << endl;
	fli_getframeoffsets(ani);

	short f_x=320, f_y=200;
	
	if (ani->width > 320) f_x = 400;
	if (ani->width > 400) f_x = 512;
	if (ani->width > 512) f_x = 640;
	if (ani->width > 640) f_x = 800;
	if (ani->width > 800) f_x = 1024;
	if (ani->width > 1024) f_x = 1280;
	if (ani->width > 1280) f_x = 1600;

	if (ani->height > 200) f_y = 240;
	if (ani->height > 240) f_y = 300;
	if (ani->height > 300) f_y = 384;
	if (ani->height > 384) f_y = 400;
	if (ani->height > 400) f_y = 480;
	if (ani->height > 480) f_y = 600;
	if (ani->height > 600) f_y = 768;
	if (ani->height > 768) f_y = 1200;

	if ((f_x == 400) && (f_y != 300))
		if (f_y<=300) f_y = 300; else { f_x = 512; f_y = 384; }
	
	if ((f_x == 512) && (f_y != 384))
		if (f_y<=384) f_y = 384; else { f_x = 640; f_y = 400; }

	short mode = -1;
	if (argc>=4)
	{
			mode = gfx_findmode(atof(argv[2]), atof(argv[3]), 8) + 0x4000;
			if (mode == -1)
				mode = gfx_findmode(atof(argv[2]), atof(argv[3]), 8);
	}		
	else
	{
			mode = gfx_findmode(f_x, f_y, 8) + 0x4000;
			if (mode == -1)
				mode = gfx_findmode(atof(argv[2]), atof(argv[3]), 8);
	}

	
	if (mode == -1)
	{
		if (argc>=4)
			cout << "\n * Videoresoluutiota " << atof(argv[2]) << "x" << atof(argv[3]) << " ei tueta!\n";
		else
			cout << "\n * Videoresoluutiota " << f_x << "x" << f_y << " ei tueta!\n";
		return;
	}

	unsigned char *vbuff;
	

	if (!VBE_getinfo()) {
		cerr << "  VESA VBE 2.0:aa ei lydetty." << endl;
		exit(1);
	}
		
  if (!VBE_getmodeinfo(mode))  {
  	cerr << " * Nytnohjain ei tue VESA nyttmoodia 0x" << hex << mode << dec << endl;
  	exit(1);
  }
  if ((vesa_width==0) || (vesa_height==0) || (vesa_bits_per_pixel==0)) {
  	cerr << " * Nytnohjain ei tue VESA nyttmoodia 0x" << hex << mode << dec << endl;
  	exit(1);
  }

  if ((vesa_mode_data->ModeAttributes & 1) && (mode > 0x4000)) 
  {
  	useLFB = 1;
  	VESA_selector = 0;
  	getLFBaddress(vesa_mode_data->PhysBasePtr, 
  								&VESA_selector);
  } else
  	useLFB = 0;
  	
	if (vesa_bytes_per_pixel==3)
			vbuff = (unsigned char*)malloc(vesa_width*vesa_height*(vesa_bytes_per_pixel+1));
	else {
		vbuff = (unsigned char*)malloc(vesa_width*vesa_height*vesa_bytes_per_pixel);
	  if (vbuff == NULL) cerr << " * Out of memory: screen double buffer" << endl;
	  memset (vbuff, 0, vesa_width*vesa_height*vesa_bytes_per_pixel);
	}

	unsigned char *buffer = (unsigned char*)malloc(ani->width*ani->height);

	setmode (mode);
	
	char ch, pause = -1, oldpixel=0;
	signed char waitvr = 1;
	short frame = 0;
	float framedisplayscale = vesa_width / ani->frames;

	long f_width = ani->width;
	long f_height = ani->height;
	if (f_width > (vesa_width)) f_width = vesa_width;
	if (f_height > (vesa_height)) f_height = vesa_height;
	
	long full_width = ani->width;

	if ((ani->width != vesa_width) || (ani->height != vesa_height))
	{
      fli_play_frame(ani, (char*)buffer, ani->width);
		_asm {
			mov esi, buffer
			mov edi, vbuff
			mov eax, f_height
			
			loop0:
			mov ecx, f_width
			rep movsb
			
			sub edi, f_width
			add edi, vesa_width
			
			sub esi, f_width
			add esi, full_width
			
			dec eax
			jnz loop0
		}
	} else
    fli_play_frame(ani, (char*)vbuff, ani->width);
	
	flippage(vbuff, vesa_width, vesa_height, vesa_bytes_per_pixel);
	for (;;)
	{
		if (pause == 1)
		{
			vbuff[int(abs(float(frame * framedisplayscale)))] = oldpixel;			
			if (kbhit()) 
			{
				ch = getch();
				if (ch == 32) pause = -1;
				if (ch == '\0' + 'K') 
				{
					frame--;
					if (frame<0) frame=0;
				}
				
				if (ch == '\0' + 'M') 
				{
					frame++;
					if (frame>(ani->frames-1)) frame=ani->frames-1;
				}
			}
		}
		else
		{
			frame++;
			if (frame>(ani->frames-1)) frame=0;
			if (kbhit()) 
			{
				ch = getch();
				if (ch == 27) break;
				if (ch == 32) pause = 1;
				if (ch == '-') waitvr++;
				if (ch == '+') waitvr--;
				if (waitvr<0) waitvr = 0;
				if (waitvr>16) waitvr = 16;
				ch = 0;
			}
		}
		ani->current = frame;
		fli_setframe(ani, frame);
		
		if (ch == 27) break;
		
		if ((ani->width != vesa_width) || (ani->height != vesa_height))
		{
       fli_play_frame(ani, (char*)buffer, ani->width);
			_asm {
				mov esi, buffer
				mov edi, vbuff
				mov eax, f_height
				
				loop0:
				mov ecx, f_width
				rep movsb
				
				sub edi, f_width
				add edi, vesa_width
				
				sub esi, f_width
				add esi, full_width
				
				dec eax
				jnz loop0
			}
		} else
      fli_play_frame(ani, (char*)vbuff, ani->width);


		if (pause == 1)
		{
			oldpixel = vbuff[int(abs(float(frame * framedisplayscale)))];
			vbuff[int(abs(float(frame * framedisplayscale)))] = 128;
		}
		flippage(vbuff, vesa_width, f_height, vesa_bytes_per_pixel);

		if ((waitvr>0) && (pause != 1))
		{
			for (int i=0; i<waitvr; i++)
			{
				if (kbhit()) 
				{
					ch = getch();
					if (ch == 27) break;
					if (ch == 32) pause = 1;
					if (ch == '-') waitvr++;
					if (ch == '+') waitvr--;
					if (waitvr<0) waitvr = 0;
					if (waitvr>16) waitvr = 16;
					ch = 0;
				}
				while (inp(0x3da) & 0x8);
				while (!(inp(0x3da) & 0x8));
			}
		}
		if (ch == 27) break;

		ch = 0;
	} //loop
	
	
	free (vbuff);
	if (useLFB) freeLFB();

	_asm 
	{
		mov eax, 0x3
		int 0x10
	}
	_settextcolor (10);
	_outtext("\n  Fliccisoitin v2.0");
	_settextcolor (15);
	_outtext(" - (C) 1998 Sami Kystil\n\n");

	cout << "            FLIC: " << argv[1] << endl;
	cout << endl;
	cout << "         Frameja: " << ani->frames-1 << endl;
	cout << "      Resoluutio: " << ani->width << "x" << ani->height << endl;
	cout << "  Tiedoston koko: " << ani->filesize << " tavua" << endl;
	cout << "  Koko purettuna: " << ani->width * ani->height * ani->frames << " tavua" <<  endl << endl;
	close_fli(ani);
}  